Thursday 16 June 2022

DP || Leetcode 5. Longest Palindromic Substring

Problem Link

In this problem, there will be given a string, we have to find the longest palindromic substring of this string.

For this purpose, we have to check all the substring we can generate. From them the longest one which is palindrome will be the answer. In the naive approach, surely will cross the time limit.

DP approach: Suppose we have a string "cababa". Lets simulate this string by building a table of 6*6.

The cell value (i,j) = 0, means starting from index i to index j of the string doesn't have a palindrome

The cell value (i,j) = 1, means starting from index i to index j of the string have a palindrome, and its size is (j-i+1)

1. A single character is a palindrome itself. so, we will fill all the diagonal(i,i) as 1. 

So, the table looks like Fig :1

                                           Fig[1]
2. We will check all of 2 size substring, they formed palindrome[if the string characters are same] or not.

    for (0,1)>> characters are 'c' and 'a' so its not a palindrome we will put 0 at (0,1) 

    for (1,2)>> characters are 'a' and 'b' so its not a palindrome we will put 0 at (1,2)

    for (2,3)>> characters are 'b' and 'a' so its not a palindrome we will put 0 at (2,3)

    ....

    ....

 

3.Then we will check if the start index i and the end index j is the same character. if they are same then we will check between them all the characters are palindrome or not. In other word mathematically we will say a range palindrome if and only if,
    s[i]==s[j] and table[i+1][j-1]==1

table[i+1][j-1] represents middle substring, if you dont catch it, you can understand this by doing some paper works.

Finally, our looks like Fig 2.

                                            Fig[2]

Code:


class Solution {
public:
    int dp[1000][1000];
    string longestPalindrome(string s) {
        int ans=1;
        int start=0,end=0;
        for(int i=0;i<(int)s.size();i++){
            dp[i][i] =1; 
        }
        for(int i=0;i<(int)s.size()-1;i++){
            if(s[i]==s[i+1]){ dp[i][i+1] = 1;ans = 2;start=i;end=i+1;}
            else dp[i][i+1] = 0;
        }
        
        for(int j=2;j<(int)s.size();j++){
            for(int i=0;i<(int)s.size()-2;i++){
                if(s[i]==s[j] && dp[i+1][j-1]==1){
                    dp[i][j] = 1;
                    ans = max(ans,j-i+1);
                    if(ans==j-i+1){
                        start = i;
                        end = j;
                    }
                }
            }
        }
        string ansString = "";
        for(int i=start;i<=end;i++){
            ansString.push_back(s[i]);
        }
        return ansString;
    }
};

Wednesday 15 June 2022

Leetcode 1048. Longest String Chain || DP

Problem Link

In this problem, there will be given array of words consisting of lowercase English letters. We have to find the longest chain of word we can make from these words. A chain between two words can make if and only if deleting only single character from one of the word makes other one. In example,
abcde->abde , abcde->bcde can have chain between them. But, abcde->adce cant.
Now, we have to find the longest chain length we can make  from these words.

Idea: Instead of making words from smaller word, we can find a smaller word from a bigger one. For this purpose,
1.We first generated all the word(size == original word size -1) from a given word and,
2.we tested which generated word is belongs to the words array. If any word is found repeat step 1-2.

So, it seems going for the all possible case we can generate  so far. But doing it in recursive naive approach surely will exceed the time limits. So, we need to use memoization.


Code[ Memoization]:

class Solution {
public:
    unordered_map<string,int>wordMap,memo;
    int ans=1;
    int caller(string str){
        if(str.size()==1){
            if(wordMap[str]!=0) memo[str]=1;
            else memo[str]=0;
            return memo[str];
        }
        if(wordMap[str]==0){
            memo[str] = 0;
            return 0;
        }
        else if(wordMap[str]!=0){
            for(int j=0;j<str.size();j++){
                string temp = str.substr(0,j) + str.substr(j+1,str.size()-j);
                if(memo[temp]==0){
                    memo[str] = max(memo[str],caller(temp)+1);
                }
                else memo[str] = max(memo[str],memo[temp]+1);
            }
        }
        return memo[str];
    }
    int longestStrChain(vector<string>& words) {
        for(int i=0;i<(int)words.size();i++){
            wordMap[words[i]]++;
        }
        for(int i=0;i<(int)words.size();i++){
            if(memo[words[i]]==0){
                memo[words[i]]=caller(words[i]);
            }
            ans = max(ans,memo[words[i]]);
        }
        return ans;
    }
};

Tuesday 14 June 2022

LCS || Leetcode 583. Delete Operation for Two Strings

Problem Link

In this problem , Given two strings. we have to make these two strings equal. In one move we can delete any character from either string. We have to do it in minimum number of steps possible.

Problem Idea: We have to reduce the strings, which makes the two strings equal. But hence we have to do it in minimum number of steps. So, we can say, we have to find such subsequence of strings that both the strings consisted. In other word we have to find the size of the longest common subsequence (LCS)

Complexity: O(m*n) ||   where m and n are size of the two strings.

Code[LCS Tabulization]:

 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
class Solution {
public:
    const static int sz = 505;
    int dp[sz][sz];
    int lcs(string s1,string s2){
        for(int i=0;i<s1.size();i++){
            dp[i][0] = 0;
        }
        for(int i=0;i<s2.size();i++){
            dp[0][i] = 0;
        }
        for(int i=1;i<=s1.size();i++){
            for(int j=1;j<=s2.size();j++){
                if(s1[i-1]==s2[j-1]){
                    dp[i][j] = dp[i-1][j-1]+1;
                }else{
                    dp[i][j] = max(dp[i-1][j],dp[i][j-1]);
                }
            }
        }
        return 2*dp[s1.size()][s2.size()];
    }
    int minDistance(string word1, string word2) {
        return word1.size()+word2.size()-lcs(word1,word2);
    }
};

Monkey Banana Problem lightoj 1004

  In this problem we will check which adjacent cell will benefits the monkey best. For this, we will check all possible solution of this pro...